# -*- coding: utf-8 -*-
"""
Created on Fri Apr  5 16:52:48 2024

@author: yj
"""

import onnx
# Import the ktc package which is our Python API.
import ktc
import cv2
import tensorflow as tf
import random
import numpy as np
import videoto3d

kneron_boardType = "630"

# Opset_version Check
model = onnx.load("./3dcnn.onnx")
opset_version = model.opset_import[0].version if len(model.opset_import) > 0 else None
print(opset_version)

# 1. Load the model.
original_m = onnx.load("./3dcnn_ops11.onnx")

# 2. Optimize the model using optimizer for onnx model.
optimized_m = ktc.onnx_optimizer.onnx2onnx_flow(original_m)
onnx.save(optimized_m, "./optimized_3dcnn.onnx")

# Save the onnx object optimized_m to path optimized.onnx.
km = ktc.ModelConfig(1, "0001", "630", onnx_path="optimized_3dcnn.onnx")
# Evaluate the model. The evaluation result is saved as string into `eval_result`.
eval_result = km.evaluate()


'''
#-- Check input
# We need to prepare a dictionary, which mapping the input name to a list of preprocessed arrays.
input_np = np.zeros([32,32,15,3])
input_np = np.expand_dims(input_np, 0)
input_mapping = {"video": input_np}

bie_path = km.analysis(input_mapping, threads = 4)
fixed_results = ktc.kneron_inference(input_data, bie_file=bie_path, input_names=["video"], platform=630)
'''

img_rows, img_cols, frames = 32, 32, 15
vid3d = videoto3d.Videoto3D(img_rows, img_cols, frames)
video_path = "./video/1.avi"
video_np = vid3d.video3d(video_path, color=True, skip=False)

video_np = np.swapaxes(video_np, 0, 1)
video_np = np.swapaxes(video_np, 1, 2)

video_np = np.expand_dims(video_np, 0)
print(video_np.shape)
#print(type(video_np))
#print(video_np.shape)

video_np_list = [video_np]
input_data = video_np_list

input_mapping = {"serving_default_conv3d_input:0": video_np_list}
bie_path = km.analysis(input_mapping, threads = 4)
fixed_results = ktc.kneron_inference(input_data, bie_file=bie_path, input_names=["serving_default_conv3d_input:0"], platform= 630)


# bin 
nef_path = ktc.compile([km])

#nef 모델이	정상작동하는지	확인
hw_results = ktc.kneron_inference(input_data,  nef_file=nef_path, input_names=["serving_default_conv3d_input:0"], platform= 630)

# Compare binary_inf_results and fixed_point_inf_results. They should be almost the same.
print("Fixed \n")
print(fixed_results)
print("HW \n")
print(hw_results)


